/// <reference types="node" />
interface ReactProxy {
    get(): any;
    update(type: any): void;
}
declare type ReactProxies = {
    [id: string]: ReactProxy;
};
declare type HotCallback = (forceUpdate: (element: any) => void) => void;
declare type WebModule = NodeModule & {
    hot?: {
        accept: () => void;
    };
};
/** Notification that some component was updated */
export declare function listen(cb: HotCallback): void;
/** Hot update helper */
export declare function hot(module?: WebModule, accept?: (module: WebModule, proxies: ReactProxies) => void): (element: any) => any;
/** Register types to be proxied - name must be unique for the fileName */
export declare function register(type: any, name: string, fileName: string): void;
export {};
