import * as ts from 'typescript';
/**
 * HMR transformer options:
 * - disable: behave like NODE_ENV=production
 * - rhRuntime: module required by the client HMR proxy
 * - keepArrows: leave arrow functions not re-wired to prototype
 */
declare type rhTransformerOptions = {
    disable?: string;
    rhRuntime?: string;
    keepArrows?: boolean;
};
/**
 * TypeScript AST transformer
 * Wraps React classes and functional components for HMR
 */
declare function rhTransformer(options: rhTransformerOptions): (context: ts.TransformationContext) => ts.Visitor;
export = rhTransformer;
